#!/usr/bin/env python
import cgi
import subprocess
import json
import os

BASE_SEARCH = ['curl', '-X', 'GET', '-u', 'build-readonly:AKCp2VokETVydLrFktqtwT5XM1vGHBaXis99BSVjyqz9RZZvkPDJ9cfDyR1Ke4PoSHhsrVYnt']
PATH_URL = 'https://artifactory-re.bit9.local/artifactory/api/storage/carbonblack/cbp/product/%s/%s/%s?list&deep=0&listFolders=1'
def getBranches():
    branches = set()
    devnull = open(os.devnull, 'w')
    products = [('server', 'windows', ['internal']), ('agent', 'lnx-rhel6', ['unsigned']), ('agent', 'lnx-rhel7', ['unsigned']), ('agent', 'windows', ['internal']), ('agent', 'osx', ['unsigned'])]
    for prod, prod_os, signing_list in products:
        for signing in signing_list:
            output = subprocess.Popen(BASE_SEARCH + [PATH_URL % (prod, prod_os, signing)], stderr=devnull,  stdout=subprocess.PIPE).communicate()[0]
            paths = json.loads(output)
            assert 'files' in paths.keys()
            for file_obj in paths['files']:
                assert 'uri' in file_obj.keys()
                branch = file_obj['uri'][1:]
                branches.add(branch)
    return branches

if __name__ == '__main__':
    print "Content Type: application/json"
    print ""
    print json.dumps(list(getBranches()))
