#!/usr/bin/perl

$HOSTNAME=`hostname`;
chomp $HOSTNAME;

if ( $HOSTNAME ne "bpuvjnmascscl01" ) {
	print "Error: Must be on host jenkins.bit9.local\n";
	exit 1;
}

$BRANCH="V723";
chomp $BRANCH;
$CRS="51615";
chomp $CRS;
$hotfix_branches_file="/transfer/hotfix-branches/hotfix-branches-live.txt";
chomp $hotfix_branches_file;

# Force failure
#$hotfix_branches_file="/tmp/kjfhdjkfhfdkjfh";

exit 1 if ( ! -e "$hotfix_branches_file" );

print "Didnt Exit...\n";

@branches=`cat $hotfix_branches_file | grep "$BRANCH"`;

print "Branches Array Before Sort: @branches\n";


foreach $branch (@branches) {
	chomp $branch;
	#print "Branch: $branch\n";
	#$branch =~ m/HF(.*)?-CR(.*)/;
	$branch =~ m/HF(\d+)(-CR|-EA)/;
	$str = $1;
	push(@branch_numbers, $str);
}

# sort numerically descending
@sorted_branch_numbers = sort {$b <=> $a} @branch_numbers;
print "Branches Array After Sort: @sorted_branch_numbers\n";


$lastver=$sorted_branch_numbers[0];
$nextver=$lastver + 1;

# Only print the name itself, no other string. This value is used by the
# next-available-hotfix.cgi script and only expects this string.
#print "\"${BRANCH}-HF${nextver}-CR-${CRS}\"\n";

print "${BRANCH}-HF${nextver}-CR-${CRS}\n";
